.pragma library

function imageFilters() {
    var filters = ["*.jpg", "*.jpeg", "*.bmp", "*.png", "*.svg", "*.tiff", "*.gif"];
    var length = filters.length;
    for(var i = 0; i < length; ++i)
        filters.push(filters[i].toUpperCase());
    return filters;
}

function videoFilters() {
    var filters = ["*.avi", "*.mp4", "*.flv", "*.ogg", "*.3gp", "*.mkv", "*.mpg", "*.mpeg", "*.mov", "*.wmv"];
    var length = filters.length;
    for(var i = 0; i < length; ++i)
        filters.push(filters[i].toUpperCase());
    return filters;
}

function documentFilters() {
    var filters = ["*.pdf"];
    var length = filters.length;
    for(var i = 0; i < length; ++i)
        filters.push(filters[i].toUpperCase());
    return filters;
}

function allFilters() {
    return imageFilters().concat(videoFilters()).concat(documentFilters());
}

function pickFilters(image, video, documents) {
    var filters = [];
    if(image)
        filters = filters.concat(imageFilters());
    if(video)
        filters = filters.concat(videoFilters());
    if(documents)
        filters = filters.concat(documentFilters());
    return filters;
}

function isVideo(path) {
    for (var i = 0; i < videoFilters().length; i++) {
        if(matchRuleShort(path, videoFilters()[i]))
            return true;
    }
    return false;
}

function isImage(path) {
    for (var i = 0; i < imageFilters().length; i++) {
        if(matchRuleShort(path, imageFilters()[i]))
            return true;
    }
    return false;
}

function isDocument(path) {
    for (var i = 0; i < documentFilters().length; i++) {
        if(matchRuleShort(path, documentFilters()[i]))
            return true;
    }
    return false;
}

function matchRuleShort(str, rule) {
  return new RegExp("^" + rule.split("*").join(".*") + "$").test(str);
}
